#property copyright "Copyright  forexeasystems.com"
#property link      "http://www.forexeasystems.com"

#property indicator_separate_window
#property indicator_minimum 0.0
#property indicator_maximum 1.0
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Maroon
#property indicator_color4 DarkSlateBlue

int Minutes = 0;
extern int ADXperiod=14;
extern double SARstep=0.02;
extern double SARshow=2;
extern int diNapoliPer=22;
extern int diNapoliBars=3000;
double g_ibuf_80[];
double g_ibuf_84[];
double g_ibuf_88[];
double g_ibuf_92[];
double g_isar_120;
double g_iadx_128;
double g_iadx_136;
double g_idiNapoli;
string gs_144;

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID );
   SetIndexBuffer(0, g_ibuf_80);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(1, g_ibuf_84);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(2, g_ibuf_88);
   SetIndexStyle(3, DRAW_HISTOGRAM, STYLE_SOLID);
   SetIndexBuffer(3, g_ibuf_92);
   switch (Minutes) {
   case 1:
      gs_144 = "Period_M1";
      break;
   case 5:
      gs_144 = "Period_M5";
      break;
   case 15:
      gs_144 = "Period_M15";
      break;
   case 30:
      gs_144 = "Period_M30";
      break;
   case 60:
      gs_144 = "Period_H1";
      break;
   case 240:
      gs_144 = "Period_H4";
      break;
   case 1440:
      gs_144 = "Period_D1";
      break;
   case 10080:
      gs_144 = "Period_W1";
      break;
   case 43200:
      gs_144 = "Period_MN1";
      break;
   default:
      gs_144 = "Current Timeframe";
      Minutes = 0;
   }
   IndicatorShortName("ProFx07 GZ(" + gs_144 + ")");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int li_unused_0 = IndicatorCounted();
   for (int li_4 = 0; li_4 < 7000; li_4++) {
      g_ibuf_80[li_4] = 0;
      g_ibuf_84[li_4] = 0;
      g_ibuf_88[li_4] = 0;
      g_ibuf_92[li_4] = 0;
      g_iadx_128 = iADX(NULL, Minutes, ADXperiod, PRICE_CLOSE, MODE_PLUSDI, li_4);
      g_iadx_136 = iADX(NULL, Minutes, ADXperiod, PRICE_CLOSE, MODE_MINUSDI, li_4);
      g_isar_120 = iSAR(NULL, Minutes, SARstep, SARshow, li_4);
      g_idiNapoli= iCustom(NULL, 0, "DiNapoli Detrend Oscillator",diNapoliPer,diNapoliBars,0,li_4);

      if (g_isar_120 < iClose(NULL, Minutes, li_4) && g_iadx_128 > g_iadx_136 && g_idiNapoli>0) g_ibuf_84[li_4] = 1;
      if (g_isar_120 < iClose(NULL, Minutes, li_4) && g_iadx_136 > g_iadx_128 && g_idiNapoli>0) g_ibuf_92[li_4] = 1;
      
      if (g_isar_120 > iClose(NULL, Minutes, li_4) && g_iadx_136 > g_iadx_128 && g_idiNapoli<0) g_ibuf_80[li_4] = 1;
      if (g_isar_120 > iClose(NULL, Minutes, li_4) && g_iadx_128 > g_iadx_136 && g_idiNapoli<0) g_ibuf_88[li_4] = 1;
      if (g_ibuf_80[li_4] == 0.0 && g_ibuf_84[li_4] == 0.0) {
      }
   }
   return (0);
}